//*******************************************************
//  ATmega48 8x8 dot matrix LED Display
//
//  file name: mega48_8x8_dot.c
//
//  q[Yݒ(fuse)
//                  SPIEN = Check
//               BODLEVEL = 4.3V
//              SUT_CKSEL = Ext.Crystal Osc 8.0-  MHz Start-up time PWRDOWN/RESER 16KCK + 14CK +65mS(bottom item)
//                 Others = No Check
//                      ||
//                      ||
//                EXTEND : 0xff
//                  HIGH : 0xDC
//                   LOW : 0xff
//
//@@@PB1:COL1 High:Active
//@@@PB2:COL2 High:Active
//@@@PC5:COL3 High:Active
//@@@PC4:COL4 High:Active
//@@@PC3:COL5 High:Active
//@@@PC2:COL6 High:Active
//@@@PC1:COL7 High:Active
//@@@PC0:COL8 High:Active
//@@@PB5:DS1(LED1)  Low:OFF, High:ON (ISP MISO)
//@@@PB4:DS2(LED2)  Low:OFF, High:ON (ISP SCK)
//@@@PB3:S1 SET SW Low:Active (ISP MOSI)
//@@@PB0:ROW1 Low:Active
//@@@PD1:ROW2 Low:Active
//@@@PD2:ROW3 Low:Active
//@@@PD3:ROW4 Low:Active
//@@@PD4:ROW5 Low:Active
//@@@PD5:ROW6 Low:Active
//@@@PD6:ROW7 Low:Active
//@@@PD7:ROW8 Low:Active
//@@@PD0:UART RX 600--9600 8N1
//@@@PC6:RESET Low:Active
//
//		ZbgɂcrPƂcrQ_łĂ鎞
//		@ZbgXCb`nmĂƎwԍ̐ݒ胂[hɂȂB
//		E߂Ɏwԍ̐ݒ
//		@݂̎wԍATbԊuœ_łȂ
//		@O`X̐JԂ\Bwԍݒ肵
//		@̐\Ă鎞ɃZbgXCb`
//		@iPbȏjƂkdcP_̂
//		@XCb`𗣂Ɛݒ肳B
//		@ZbgXCb`ZiODTbȉjƎ̐ݒ荀ڂɂȂ
//		EʐM̐ݒ
//		@݂̎w蕶ATbԊuœ_łȂ
//		@f`fAfafAfbfAfcfAfdfAf`fDDDD̏ɕJԂ\B
//		@ʐMaorݒ肵́@̕\Ă鎞ɃZbgXCb`
//		@iPbȏjƂkdc_̂
//		@XCb`𗣂Ɛݒ肳B
//		@ZbgXCb`ZiODTbȉjƎ̐ݒ荀ڂɂȂ
//		E̎f~^R[h̐ݒ
//		@݂̎wR[hATbԊuœ_łȂ
//		@fCRfAfLFfDDDD̏ɕJԂ\B
//		@wԍݒ肵́@̐\Ă鎞ɃZbgXCb`
//		@iPbȏjƂkdc_̂
//		@XCb`𗣂Ɛݒ肳B
//		@ZbgXCb`ZiODTbȉjƎ̐ݒ荀ڂɂȂ
//		E̎El̐ݒ
//		@݂̉Eړʂ́fWf\ATbԊuœ_łȂ
//		@fWf̕\EɂPhbgĕ\B
//		@Elʐݒ肵́@̈ʒuŁfWf\Ă鎞ɃZbgXCb`
//		@iPbȏjƂkdc_̂
//		@XCb`𗣂Ɛݒ肳B
//		@ZbgXCb`ZiODTbȉjƎ̐ݒ荀ڂɂȂ
//		@̐ݒ荀ڂ͎wԍɖ߂
//
//
// wԍ̐
//@`rbhhŁ@O@P@Q@R@S@T@U@V@W@X@ƑMꂽ
//@@@@@@@@b@b@b@b@b@b@b@b@b@b
//@@@@@@@@b@b@b@b@b@b@b@b@b@{@O̎wԍŕ\
//@@@@@@@@b@b@b@b@b@b@b@b@{||@P̎wԍŕ\
//@@@@@@@@b@b@b@b@b@b@b@{||||@Q̎wԍŕ\
//@@@@@@@@b@b@b@b@b@b@{||||||@R̎wԍŕ\
//@@@@@@@@b@b@b@b@b@{||||||||@S̎wԍŕ\
//@@@@@@@@b@b@b@b@{||||||||||@T̎wԍŕ\
//@@@@@@@@b@b@b@{||||||||||||@U̎wԍŕ\
//@@@@@@@@b@b@{||||||||||||||@V̎wԍŕ\
//@@@@@@@@b@{||||||||||||||||@W̎wԍŕ\
//@@@@@@@@{||||||||||||||||||@X̎wԍŕ\
//
// w蕶̐iʐMaorj
//		@'A':600BPS				2021/06/23 add 600bps
//		@'B':1200BPS
//		@'C':2400BPS
//		@'D':4800BPS
//		@'E':9600BPS
//
// f~^R[h̐
//		@'LF':0x0a(LF Ctrol-J)
//		@'CR':0x0d(CR Ctrol-M)
//
// ahs[h͖
//
//  2015/02/05  New(TAB4)  Taishi
//  2021/06/23  modify     Taishi add 600bps
//  2022/10/24  modify     taishi for nega48 & Character Mode only, Anode Common only
//*******************************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/pgmspace.h>


#include	"mega48_8x8_dot_h.h"
#include	"ofont8x8_h.h"
#include	"timer_h.h"
#include	"eep_dat_h.h"
#include	"uart_h.h"
#include	"port_bit_h.h"
#include	"ad_conv_h.h"
#include	"disp_8x8_dot_h.h"
#include	"set_8x8_dot_h.h"




							
unsigned char	target_number=0;				// Ԗڂ̕\邩̔ԍ(0--9)
unsigned char	bps_character='E';				// ʐMaorw肷镶(A:600 B:1200, C:2400, D:4800, E:9600)
unsigned char	delimiter_cord=0x0d;			// f~^R[h(0x0a or 0x0d)
unsigned char	right_side_no = 0;				// El
unsigned char	mirror_touritu = 0;					// A|̗L 0: 1: 2:| 3:|

static	unsigned char	recieved_data[13];				// VAŎ󂯂f[^


// *****************************
// LN^[h̏
// *****************************
static	void	proc_char_mode(void)
{
	unsigned char	i;
	unsigned char	uc;
	unsigned char	n;

	for(i=0;i<12;i++){
		recieved_data[i] = ' ';									// VAŎ󂯂f[^NA
	}
	while(1){
		if(uart_rx_one(&uc) == 1){								// ML
			led_ds2_on();										// LED2 ON								// Ԃ𑪂
			for(i=10; 0 < i; i--){
				recieved_data[i] = recieved_data[i-1];			// VAŎ󂯂f[^
			}
			recieved_data[0] = uc;								// VAŎ󂯂f[^𒙂߂
			if(uc == delimiter_cord){							// ̎̏Ԃ͖UQOr
				n = recieved_data[target_number+1];				// VAŎ󂯂f[^̎wԍǂ
				asc_to_dotmatrix(n,right_side_no,mirror_touritu);	// AXL[hbg}gbNXf[^ɕϊ
				for(i=0;i<12;i++){
					recieved_data[i] = ' ';						// VAŎ󂯂f[^NA
				}
			}
			led_ds2_off();										// LED2 OFF				Ԃ𑪂
		}

	}
}
// *****************************
//	main
// *****************************
int	main(void)
{
	unsigned short	i;
	unsigned char	j;

	MCUCR &= ~(1 << PUD);			// SẴvAbv֎~ɂ͂Ȃ

//				    76543210		//  |[gc
	PORTD	    = 0b00000001;		//	o̓f[^ݒ(PD0(RXD) ȊOSĂO,off)
	DDRD 		= 0b11111110;		//  o͕ݒ(PD1,2,3,4,5,6,7:Output)


//				    76543210		//  |[ga
	PORTB	    = 0b00111111;		//	o̓f[^ݒ
	DDRB 		= 0b00110111;		//  o͕ݒ(PB0,3=)
	PORTB	    = 0b00001001;		//	vAbvݒ(PB0=off,PB1,2,4,5=off,PB3=vAbvLARB0&3=1)


//				    76543210		//  |[gb
	PORTC	    = 0b00000000;		//	o̓f[^ݒ(SĂO,off)
	DDRC 		= 0b11111111;		//  o͕ݒ(PC=Sďo)

	led_ds_init();					// Port-B Bit4,5 : Output


	delay_ms(500);					// Wait 500mSec


	read_eeprom_save_data();		// ddoqnl ۑڂǍ
	ad7_init();						// A/D 7 Initial

	led_ds1_on();
	for(i=0;i<10;i++){
		led_ds1_toggle();								//  LED1 Toggle
		led_ds2_toggle();								//  LED2 Toggle
		j = (SW_PORT & (SW1_ON_BIT));
		delay_ms(500);									// Wait 500mSec
		if(j == (SW_PORT & (SW1_ON_BIT))){
			if(j == 0){									// SET SW:ON
				setpro();								// ݒ菈
			}
		}
	}
	led_ds1_off();										// LED OFF
	led_ds2_off();										// LED OFF

	uart_init_trx(0);									// UART ݒ RX only

	timer2_init();										// Timer2 ݒ
	sei();												// 荞݉

	proc_char_mode();									// LN^[h̏

// ȉ`FbNp@KXCȂg
#if	0
	{
		unsigned char	n;

		n = 0x00;
		for(;;){
			asc_to_dotmatrix(n,0,0);					// AXL[hbg}gbNXf[^ɕϊ
			n++;
			n &= 0x7f;
			delay_ms(5000);								// Wait 1Sec
		}
	}
#endif

#if	0
	cli();
	for(;;){
		for(i=0;i<8;i++){
			PORTB |= row_data_PB_off;		// row off
			PORTD |= row_data_PD_off;		// row off
			PORTB &= col_data_PB_off;		// col off
			PORTC &= col_data_PC_off;		// col off

			PORTB &= row_data_PB[i];		// row set
			PORTD &= row_data_PD[i];		// row set

			for(j=0;j<8;j++){
				PORTB &= col_data_PB_off;	// col off
				PORTC &= col_data_PC_off;	// col off

				PORTB |= col_data_PB[j];	// col set
				PORTC |= col_data_PC[j];	// col set

				delay_ms(250);				// Wait 250mSec
				led_ds1_on();
				led_ds2_off();
				delay_ms(250);				// Wait 250mSec
				led_ds1_off();
				led_ds2_on();
			}
		}
	}
#endif
}
